// This example will allow us to explore
// classes, data members, member functions,
// constructor, destructors, function overloading,
// operator overloading, etc. We are building
// these ideas around a Rational object

// History: 2/16 - Completed the copy assignment overloaded operator (=) to work with
//                 Rational objects. We discussed the "this" pointer. We also looked
//                 into basic file processing in C++, specifically input streams and
//                 reading basic types from the file.

#include "Rational.hpp"

int main(void)
{
	Rational r1(0, 1), r2(5, 2), r3, r4(7), r5 = r3 /* this = is the copy constructor */;

	cout << "address of r1: " << &r1 << endl; // should match the value printed by
	                                          // the overloaded assignment operator

	r1 = r2; // overloaded assignment operator for Rational objects

	// the lines below will help with PA 4 - this is one way to open files and
	// then read some data from them
	ifstream inputStream; // we could use the constructor for ifstream object to open
	                      // the file as well; just wanted to show the call to open below

	inputStream.open("Rational.txt", std::ios::in); // by default the file is already open
	                                             // in mode "in" because of the object type
	                                             // which is "ifstream"

	if (inputStream.is_open()) // is the file open? - please investigate the various
		                       // member functions of ifstream objects by leveraging
		                       // VS Community's IntelliSense
	{
		//inputStream >> r1; // doesn't work until we overload the stream insertion for >> to work with Rational objects
		
		cout << "rational number read from file: "; // added after class on Fri, 2/16
		int num;
		inputStream >> num; // get the first int on the line
		char slash;
		inputStream >> slash; // get the / on the line, white space is already ignored
		int den;
		inputStream >> den; // get the second int on the line
		cout << num << slash << den << endl; // added after class on Fri, 2/16
		
		//char line[100];
		//inputStream.getline(line, 100); // similar to fgets () - reads the entire line
	
		inputStream.close(); // close the input file stream - added after class on Fri, 2/16
	}

	return 0;
}